# dGTS3.py
# Version: 3.1
# Author: Diego Mariano
# Date: April 24, 2017
# Realiza o experimento 1


# IMPORT ***********************************************************************************************************************
from math import sqrt
import sys
import glob
import numpy as np

# OPEN FILE ********************************************************************************************************************
signature_matrix = "assinaturas.csv"
print "* CALCULATING ddGTS *\n"
major = 0

try:
	r = open(sys.argv[1]).readlines()
except:
	r = open(signature_matrix).readlines()


# GENERAL DEFINITIONS **********************************************************************************************************
#lines	1:23	tolerants
#lines	24:50	mutants
#lines	51:77	selvagem 

dGTS = []
ddGTS = [] 
num_signatures = len(r)
tolerants = range(23)
num_tolerants = len(tolerants)

# number of columns
columns = len(r[0].split(","))


# TEMPLATE DEFINITION FOR EACH MUTANT AND WILD **********************************************************************************

#nearest ************************************************************************************************************************
nearest = [] # value: template ID => index: bgl id
dist_nearest = [] #  euclidian distance bgl - template

for i in range(num_signatures):
	nearest.append(-1)
	dist_nearest.append(0)
#END nearest ********************************************************************************************************************


for i in range(num_signatures):

	dist_nearest_min = 1000000000000000
	GTS_bgl = r[i].split(",")
		
	# For each tolerant
	for j in range(num_tolerants):

		# Special rule for Metagenome Turpan Depression (second in list) => j = 11; i = 24; i = 51
		if j == 11 and (i == 24 or i == 51):
			continue
			
		GTS_tolerant = r[j].split(",")

		dist = 0

		# Euclidian distance
		for k in range(columns):
			dist += (float(GTS_bgl[k]) - float(GTS_tolerant[k]))**2		
			
		dist = sqrt(dist)

		if dist < dist_nearest_min:
			dist_nearest_min = dist
			id_nearest = j


	nearest[i] = id_nearest
	dist_nearest[i] = dist_nearest_min

#print nearest
#print dist_nearest

# ddGTS CALCULATION *************************************************************************************************************
num_mutations = 27
id_mutant = num_tolerants # starts at 23
id_wild = id_mutant + num_mutations # starts at 50


for i in range(num_mutations):
	
	each_ddGTS = dist_nearest[id_mutant] - dist_nearest[id_wild] 
	ddGTS.append(each_ddGTS)

	id_mutant += 1
	id_wild += 1



# prints ************************************************************************************************************************
def translateMutation(m):

	# Case study 1
	tradutions = ["H228T","V174C / A404V / L441F","H184F","P172L","P172L/F250A","L167W","L167W/P172L ","L167W/P172L/ P338F","V168Y","F225S","Y308F","Y308A","I207V","N218H","N273V","F252I","F252W","F252Y","M284N","H276M","V173C","M177L","D229N","H231D","E96K","N223G","N223Q"]

	# Case study 2
	#tradutions = ["betagdb_1","betagdb_2","betagdb_3","betagdb_4","betagdb_5","betagdb_6","betagdb_7","betagdb_8","betagdb_9","betagdb_10","betagdb_11","betagdb_12","betagdb_13","betagdb_14","betagdb_15","betagdb_16","betagdb_17","betagdb_18","betagdb_19","betagdb_20","betagdb_21","betagdb_22","betagdb_23","yang/d0ALA125.pdb_temp.pdb", "yang/d0GLU298.pdb_temp.pdb", "yang/d0PHE226.pdb_temp.pdb", "yang/d0ALA126.pdb_temp.pdb", "yang/d0GLU299.pdb_temp.pdb", "yang/d0PHE227.pdb_temp.pdb", "yang/d0ALA169.pdb_temp.pdb", "yang/d0GLU301.pdb_temp.pdb", "yang/d0PHE228.pdb_temp.pdb", "yang/d0ALA170.pdb_temp.pdb", "yang/d0GLU399.pdb_temp.pdb", "yang/d0PHE246.pdb_temp.pdb", "yang/d0ALA172.pdb_temp.pdb", "yang/d0GLU407.pdb_temp.pdb", "yang/d0PHE296.pdb_temp.pdb", "yang/d0ALA173.pdb_temp.pdb", "yang/d0GLU415.pdb_temp.pdb", "yang/d0PHE297.pdb_temp.pdb", "yang/d0ALA177.pdb_temp.pdb", "yang/d0GLY125.pdb_temp.pdb", "yang/d0PHE298.pdb_temp.pdb", "yang/d0ALA184.pdb_temp.pdb", "yang/d0GLY126.pdb_temp.pdb", "yang/d0PHE299.pdb_temp.pdb", "yang/d0ALA226.pdb_temp.pdb", "yang/d0GLY169.pdb_temp.pdb", "yang/d0PHE301.pdb_temp.pdb", "yang/d0ALA227.pdb_temp.pdb", "yang/d0GLY170.pdb_temp.pdb", "yang/d0PHE353.pdb_temp.pdb", "yang/d0ALA228.pdb_temp.pdb", "yang/d0GLY172.pdb_temp.pdb", "yang/d0PHE399.pdb_temp.pdb", "yang/d0ALA246.pdb_temp.pdb", "yang/d0GLY173.pdb_temp.pdb", "yang/d0PHE406.pdb_temp.pdb", "yang/d0ALA296.pdb_temp.pdb", "yang/d0GLY177.pdb_temp.pdb", "yang/d0PHE407.pdb_temp.pdb", "yang/d0ALA297.pdb_temp.pdb", "yang/d0GLY184.pdb_temp.pdb", "yang/d0PRO125.pdb_temp.pdb", "yang/d0ALA298.pdb_temp.pdb", "yang/d0GLY226.pdb_temp.pdb", "yang/d0PRO126.pdb_temp.pdb", "yang/d0ALA299.pdb_temp.pdb", "yang/d0GLY227.pdb_temp.pdb", "yang/d0PRO169.pdb_temp.pdb", "yang/d0ALA301.pdb_temp.pdb", "yang/d0GLY228.pdb_temp.pdb", "yang/d0PRO170.pdb_temp.pdb", "yang/d0ALA353.pdb_temp.pdb", "yang/d0GLY296.pdb_temp.pdb", "yang/d0PRO172.pdb_temp.pdb", "yang/d0ALA399.pdb_temp.pdb", "yang/d0GLY297.pdb_temp.pdb", "yang/d0PRO173.pdb_temp.pdb", "yang/d0ALA406.pdb_temp.pdb", "yang/d0GLY298.pdb_temp.pdb", "yang/d0PRO177.pdb_temp.pdb", "yang/d0ALA407.pdb_temp.pdb", "yang/d0GLY299.pdb_temp.pdb", "yang/d0PRO184.pdb_temp.pdb", "yang/d0ALA415.pdb_temp.pdb", "yang/d0GLY301.pdb_temp.pdb", "yang/d0PRO226.pdb_temp.pdb", "yang/d0ARG125.pdb_temp.pdb", "yang/d0GLY353.pdb_temp.pdb", "yang/d0PRO227.pdb_temp.pdb", "yang/d0ARG126.pdb_temp.pdb", "yang/d0GLY399.pdb_temp.pdb", "yang/d0PRO228.pdb_temp.pdb", "yang/d0ARG169.pdb_temp.pdb", "yang/d0GLY406.pdb_temp.pdb", "yang/d0PRO246.pdb_temp.pdb", "yang/d0ARG170.pdb_temp.pdb", "yang/d0GLY407.pdb_temp.pdb", "yang/d0PRO296.pdb_temp.pdb", "yang/d0ARG172.pdb_temp.pdb", "yang/d0GLY415.pdb_temp.pdb", "yang/d0PRO297.pdb_temp.pdb", "yang/d0ARG173.pdb_temp.pdb", "yang/d0HIS126.pdb_temp.pdb", "yang/d0PRO298.pdb_temp.pdb", "yang/d0ARG177.pdb_temp.pdb", "yang/d0HIS169.pdb_temp.pdb", "yang/d0PRO299.pdb_temp.pdb", "yang/d0ARG184.pdb_temp.pdb", "yang/d0HIS170.pdb_temp.pdb", "yang/d0PRO301.pdb_temp.pdb", "yang/d0ARG226.pdb_temp.pdb", "yang/d0HIS172.pdb_temp.pdb", "yang/d0PRO353.pdb_temp.pdb", "yang/d0ARG227.pdb_temp.pdb", "yang/d0HIS173.pdb_temp.pdb", "yang/d0PRO399.pdb_temp.pdb", "yang/d0ARG228.pdb_temp.pdb", "yang/d0HIS177.pdb_temp.pdb", "yang/d0PRO406.pdb_temp.pdb", "yang/d0ARG246.pdb_temp.pdb", "yang/d0HIS226.pdb_temp.pdb", "yang/d0PRO407.pdb_temp.pdb", "yang/d0ARG296.pdb_temp.pdb", "yang/d0HIS227.pdb_temp.pdb", "yang/d0PRO415.pdb_temp.pdb", "yang/d0ARG297.pdb_temp.pdb", "yang/d0HIS246.pdb_temp.pdb", "yang/d0SER125.pdb_temp.pdb", "yang/d0ARG298.pdb_temp.pdb", "yang/d0HIS296.pdb_temp.pdb", "yang/d0SER126.pdb_temp.pdb", "yang/d0ARG299.pdb_temp.pdb", "yang/d0HIS297.pdb_temp.pdb", "yang/d0SER169.pdb_temp.pdb", "yang/d0ARG301.pdb_temp.pdb", "yang/d0HIS298.pdb_temp.pdb", "yang/d0SER170.pdb_temp.pdb", "yang/d0ARG353.pdb_temp.pdb", "yang/d0HIS299.pdb_temp.pdb", "yang/d0SER172.pdb_temp.pdb", "yang/d0ARG399.pdb_temp.pdb", "yang/d0HIS301.pdb_temp.pdb", "yang/d0SER173.pdb_temp.pdb", "yang/d0ARG406.pdb_temp.pdb", "yang/d0HIS353.pdb_temp.pdb", "yang/d0SER177.pdb_temp.pdb", "yang/d0ARG407.pdb_temp.pdb", "yang/d0HIS399.pdb_temp.pdb", "yang/d0SER184.pdb_temp.pdb", "yang/d0ARG415.pdb_temp.pdb", "yang/d0HIS406.pdb_temp.pdb", "yang/d0SER226.pdb_temp.pdb", "yang/d0ASN125.pdb_temp.pdb", "yang/d0HIS407.pdb_temp.pdb", "yang/d0SER227.pdb_temp.pdb", "yang/d0ASN126.pdb_temp.pdb", "yang/d0HIS415.pdb_temp.pdb", "yang/d0SER228.pdb_temp.pdb", "yang/d0ASN170.pdb_temp.pdb", "yang/d0ILE125.pdb_temp.pdb", "yang/d0SER246.pdb_temp.pdb", "yang/d0ASN172.pdb_temp.pdb", "yang/d0ILE126.pdb_temp.pdb", "yang/d0SER296.pdb_temp.pdb", "yang/d0ASN173.pdb_temp.pdb", "yang/d0ILE169.pdb_temp.pdb", "yang/d0SER297.pdb_temp.pdb", "yang/d0ASN177.pdb_temp.pdb", "yang/d0ILE170.pdb_temp.pdb", "yang/d0SER298.pdb_temp.pdb", "yang/d0ASN184.pdb_temp.pdb", "yang/d0ILE172.pdb_temp.pdb", "yang/d0SER299.pdb_temp.pdb", "yang/d0ASN227.pdb_temp.pdb", "yang/d0ILE173.pdb_temp.pdb", "yang/d0SER301.pdb_temp.pdb", "yang/d0ASN228.pdb_temp.pdb", "yang/d0ILE177.pdb_temp.pdb", "yang/d0SER353.pdb_temp.pdb", "yang/d0ASN246.pdb_temp.pdb", "yang/d0ILE184.pdb_temp.pdb", "yang/d0SER399.pdb_temp.pdb", "yang/d0ASN297.pdb_temp.pdb", "yang/d0ILE226.pdb_temp.pdb", "yang/d0SER406.pdb_temp.pdb", "yang/d0ASN298.pdb_temp.pdb", "yang/d0ILE227.pdb_temp.pdb", "yang/d0SER407.pdb_temp.pdb", "yang/d0ASN299.pdb_temp.pdb", "yang/d0ILE228.pdb_temp.pdb", "yang/d0SER415.pdb_temp.pdb", "yang/d0ASN353.pdb_temp.pdb", "yang/d0ILE246.pdb_temp.pdb", "yang/d0THR125.pdb_temp.pdb", "yang/d0ASN399.pdb_temp.pdb", "yang/d0ILE296.pdb_temp.pdb", "yang/d0THR126.pdb_temp.pdb", "yang/d0ASN406.pdb_temp.pdb", "yang/d0ILE297.pdb_temp.pdb", "yang/d0THR169.pdb_temp.pdb", "yang/d0ASN407.pdb_temp.pdb", "yang/d0ILE298.pdb_temp.pdb", "yang/d0THR170.pdb_temp.pdb", "yang/d0ASN415.pdb_temp.pdb", "yang/d0ILE299.pdb_temp.pdb", "yang/d0THR172.pdb_temp.pdb", "yang/d0ASP125.pdb_temp.pdb", "yang/d0ILE301.pdb_temp.pdb", "yang/d0THR173.pdb_temp.pdb", "yang/d0ASP126.pdb_temp.pdb", "yang/d0ILE353.pdb_temp.pdb", "yang/d0THR177.pdb_temp.pdb", "yang/d0ASP169.pdb_temp.pdb", "yang/d0ILE399.pdb_temp.pdb", "yang/d0THR184.pdb_temp.pdb", "yang/d0ASP170.pdb_temp.pdb", "yang/d0ILE406.pdb_temp.pdb", "yang/d0THR226.pdb_temp.pdb", "yang/d0ASP172.pdb_temp.pdb", "yang/d0ILE407.pdb_temp.pdb", "yang/d0THR227.pdb_temp.pdb", "yang/d0ASP173.pdb_temp.pdb", "yang/d0ILE415.pdb_temp.pdb", "yang/d0THR228.pdb_temp.pdb", "yang/d0ASP177.pdb_temp.pdb", "yang/d0LEU125.pdb_temp.pdb", "yang/d0THR246.pdb_temp.pdb", "yang/d0ASP184.pdb_temp.pdb", "yang/d0LEU126.pdb_temp.pdb", "yang/d0THR296.pdb_temp.pdb", "yang/d0ASP226.pdb_temp.pdb", "yang/d0LEU169.pdb_temp.pdb", "yang/d0THR297.pdb_temp.pdb", "yang/d0ASP227.pdb_temp.pdb", "yang/d0LEU170.pdb_temp.pdb", "yang/d0THR298.pdb_temp.pdb", "yang/d0ASP228.pdb_temp.pdb", "yang/d0LEU172.pdb_temp.pdb", "yang/d0THR301.pdb_temp.pdb", "yang/d0ASP246.pdb_temp.pdb", "yang/d0LEU173.pdb_temp.pdb", "yang/d0THR353.pdb_temp.pdb", "yang/d0ASP296.pdb_temp.pdb", "yang/d0LEU184.pdb_temp.pdb", "yang/d0THR399.pdb_temp.pdb", "yang/d0ASP297.pdb_temp.pdb", "yang/d0LEU226.pdb_temp.pdb", "yang/d0THR406.pdb_temp.pdb", "yang/d0ASP298.pdb_temp.pdb", "yang/d0LEU227.pdb_temp.pdb", "yang/d0THR407.pdb_temp.pdb", "yang/d0ASP299.pdb_temp.pdb", "yang/d0LEU228.pdb_temp.pdb", "yang/d0THR415.pdb_temp.pdb", "yang/d0ASP301.pdb_temp.pdb", "yang/d0LEU246.pdb_temp.pdb", "yang/d0TRP125.pdb_temp.pdb", "yang/d0ASP353.pdb_temp.pdb", "yang/d0LEU296.pdb_temp.pdb", "yang/d0TRP169.pdb_temp.pdb", "yang/d0ASP399.pdb_temp.pdb", "yang/d0LEU297.pdb_temp.pdb", "yang/d0TRP170.pdb_temp.pdb", "yang/d0ASP406.pdb_temp.pdb", "yang/d0LEU298.pdb_temp.pdb", "yang/d0TRP172.pdb_temp.pdb", "yang/d0ASP407.pdb_temp.pdb", "yang/d0LEU299.pdb_temp.pdb", "yang/d0TRP173.pdb_temp.pdb", "yang/d0ASP415.pdb_temp.pdb", "yang/d0LEU301.pdb_temp.pdb", "yang/d0TRP177.pdb_temp.pdb", "yang/d0CYS125.pdb_temp.pdb", "yang/d0LEU353.pdb_temp.pdb", "yang/d0TRP184.pdb_temp.pdb", "yang/d0CYS126.pdb_temp.pdb", "yang/d0LEU399.pdb_temp.pdb", "yang/d0TRP226.pdb_temp.pdb", "yang/d0CYS169.pdb_temp.pdb", "yang/d0LEU406.pdb_temp.pdb", "yang/d0TRP227.pdb_temp.pdb", "yang/d0CYS170.pdb_temp.pdb", "yang/d0LEU407.pdb_temp.pdb", "yang/d0TRP228.pdb_temp.pdb", "yang/d0CYS172.pdb_temp.pdb", "yang/d0LEU415.pdb_temp.pdb", "yang/d0TRP246.pdb_temp.pdb", "yang/d0CYS177.pdb_temp.pdb", "yang/d0LYS125.pdb_temp.pdb", "yang/d0TRP296.pdb_temp.pdb", "yang/d0CYS184.pdb_temp.pdb", "yang/d0LYS126.pdb_temp.pdb", "yang/d0TRP297.pdb_temp.pdb", "yang/d0CYS226.pdb_temp.pdb", "yang/d0LYS169.pdb_temp.pdb", "yang/d0TRP298.pdb_temp.pdb", "yang/d0CYS227.pdb_temp.pdb", "yang/d0LYS170.pdb_temp.pdb", "yang/d0TRP299.pdb_temp.pdb", "yang/d0CYS228.pdb_temp.pdb", "yang/d0LYS172.pdb_temp.pdb", "yang/d0TRP301.pdb_temp.pdb", "yang/d0CYS246.pdb_temp.pdb", "yang/d0LYS173.pdb_temp.pdb", "yang/d0TRP353.pdb_temp.pdb", "yang/d0CYS296.pdb_temp.pdb", "yang/d0LYS177.pdb_temp.pdb", "yang/d0TRP406.pdb_temp.pdb", "yang/d0CYS297.pdb_temp.pdb", "yang/d0LYS184.pdb_temp.pdb", "yang/d0TRP415.pdb_temp.pdb", "yang/d0CYS298.pdb_temp.pdb", "yang/d0LYS226.pdb_temp.pdb", "yang/d0TYR125.pdb_temp.pdb", "yang/d0CYS299.pdb_temp.pdb", "yang/d0LYS227.pdb_temp.pdb", "yang/d0TYR126.pdb_temp.pdb", "yang/d0CYS301.pdb_temp.pdb", "yang/d0LYS228.pdb_temp.pdb", "yang/d0TYR169.pdb_temp.pdb", "yang/d0CYS353.pdb_temp.pdb", "yang/d0LYS246.pdb_temp.pdb", "yang/d0TYR170.pdb_temp.pdb", "yang/d0CYS399.pdb_temp.pdb", "yang/d0LYS296.pdb_temp.pdb", "yang/d0TYR172.pdb_temp.pdb", "yang/d0CYS406.pdb_temp.pdb", "yang/d0LYS297.pdb_temp.pdb", "yang/d0TYR173.pdb_temp.pdb", "yang/d0CYS407.pdb_temp.pdb", "yang/d0LYS298.pdb_temp.pdb", "yang/d0TYR177.pdb_temp.pdb", "yang/d0CYS415.pdb_temp.pdb", "yang/d0LYS299.pdb_temp.pdb", "yang/d0TYR184.pdb_temp.pdb", "yang/d0GLN125.pdb_temp.pdb", "yang/d0LYS301.pdb_temp.pdb", "yang/d0TYR226.pdb_temp.pdb", "yang/d0GLN126.pdb_temp.pdb", "yang/d0LYS353.pdb_temp.pdb", "yang/d0TYR227.pdb_temp.pdb", "yang/d0GLN169.pdb_temp.pdb", "yang/d0LYS399.pdb_temp.pdb", "yang/d0TYR228.pdb_temp.pdb", "yang/d0GLN170.pdb_temp.pdb", "yang/d0LYS406.pdb_temp.pdb", "yang/d0TYR246.pdb_temp.pdb", "yang/d0GLN172.pdb_temp.pdb", "yang/d0LYS407.pdb_temp.pdb", "yang/d0TYR296.pdb_temp.pdb", "yang/d0GLN173.pdb_temp.pdb", "yang/d0LYS415.pdb_temp.pdb", "yang/d0TYR299.pdb_temp.pdb", "yang/d0GLN177.pdb_temp.pdb", "yang/d0MET125.pdb_temp.pdb", "yang/d0TYR301.pdb_temp.pdb", "yang/d0GLN184.pdb_temp.pdb", "yang/d0MET126.pdb_temp.pdb", "yang/d0TYR353.pdb_temp.pdb", "yang/d0GLN226.pdb_temp.pdb", "yang/d0MET169.pdb_temp.pdb", "yang/d0TYR399.pdb_temp.pdb", "yang/d0GLN227.pdb_temp.pdb", "yang/d0MET170.pdb_temp.pdb", "yang/d0TYR406.pdb_temp.pdb", "yang/d0GLN228.pdb_temp.pdb", "yang/d0MET172.pdb_temp.pdb", "yang/d0TYR407.pdb_temp.pdb", "yang/d0GLN246.pdb_temp.pdb", "yang/d0MET173.pdb_temp.pdb", "yang/d0TYR415.pdb_temp.pdb", "yang/d0GLN296.pdb_temp.pdb", "yang/d0MET177.pdb_temp.pdb", "yang/d0VAL125.pdb_temp.pdb", "yang/d0GLN297.pdb_temp.pdb", "yang/d0MET184.pdb_temp.pdb", "yang/d0VAL126.pdb_temp.pdb", "yang/d0GLN298.pdb_temp.pdb", "yang/d0MET226.pdb_temp.pdb", "yang/d0VAL169.pdb_temp.pdb", "yang/d0GLN299.pdb_temp.pdb", "yang/d0MET227.pdb_temp.pdb", "yang/d0VAL170.pdb_temp.pdb", "yang/d0GLN301.pdb_temp.pdb", "yang/d0MET228.pdb_temp.pdb", "yang/d0VAL172.pdb_temp.pdb", "yang/d0GLN353.pdb_temp.pdb", "yang/d0MET246.pdb_temp.pdb", "yang/d0VAL173.pdb_temp.pdb", "yang/d0GLN399.pdb_temp.pdb", "yang/d0MET296.pdb_temp.pdb", "yang/d0VAL177.pdb_temp.pdb", "yang/d0GLN406.pdb_temp.pdb", "yang/d0MET297.pdb_temp.pdb", "yang/d0VAL184.pdb_temp.pdb", "yang/d0GLN407.pdb_temp.pdb", "yang/d0MET298.pdb_temp.pdb", "yang/d0VAL226.pdb_temp.pdb", "yang/d0GLN415.pdb_temp.pdb", "yang/d0MET299.pdb_temp.pdb", "yang/d0VAL228.pdb_temp.pdb", "yang/d0GLU125.pdb_temp.pdb", "yang/d0MET301.pdb_temp.pdb", "yang/d0VAL246.pdb_temp.pdb", "yang/d0GLU126.pdb_temp.pdb", "yang/d0MET353.pdb_temp.pdb", "yang/d0VAL296.pdb_temp.pdb", "yang/d0GLU169.pdb_temp.pdb", "yang/d0MET399.pdb_temp.pdb", "yang/d0VAL297.pdb_temp.pdb", "yang/d0GLU172.pdb_temp.pdb", "yang/d0MET406.pdb_temp.pdb", "yang/d0VAL298.pdb_temp.pdb", "yang/d0GLU173.pdb_temp.pdb", "yang/d0MET407.pdb_temp.pdb", "yang/d0VAL299.pdb_temp.pdb", "yang/d0GLU177.pdb_temp.pdb", "yang/d0MET415.pdb_temp.pdb", "yang/d0VAL301.pdb_temp.pdb", "yang/d0GLU184.pdb_temp.pdb", "yang/d0PHE125.pdb_temp.pdb", "yang/d0VAL353.pdb_temp.pdb", "yang/d0GLU226.pdb_temp.pdb", "yang/d0PHE126.pdb_temp.pdb", "yang/d0VAL399.pdb_temp.pdb", "yang/d0GLU227.pdb_temp.pdb", "yang/d0PHE169.pdb_temp.pdb", "yang/d0VAL406.pdb_temp.pdb", "yang/d0GLU228.pdb_temp.pdb", "yang/d0PHE170.pdb_temp.pdb", "yang/d0VAL407.pdb_temp.pdb", "yang/d0GLU246.pdb_temp.pdb", "yang/d0PHE173.pdb_temp.pdb", "yang/d0VAL415.pdb_temp.pdb", "yang/d0GLU296.pdb_temp.pdb", "yang/d0PHE177.pdb_temp.pdb", "yang/d0GLU297.pdb_temp.pdb", "yang/d0PHE184.pdb_temp.pdb", "wild"]
	
	return tradutions[m]

def translateSpecie(s):
	s = int(s)
	specie = ["Acidilobus saccharovorans", "Bacillus subtilis", "Caldicellulosiruptor bescii", "Exiguobacterium antarcticum B7", "Fervidobacterium islandicum", "Humicola grisea var thermoidea", "Hypocrea jecorina Trichoderma reesei", "Metagenome China South Sea", "Metagenome hydrothermal spring", "Metagenome Kusaya gravy", "Metagenome soil", "Metagenome Turpan Depression", "Mucor circinelloides", "Nasutitermes takasagoensis", "Neotermes koshunensis", "Neurospora crassa", "Pyrococcus furiosus", "Talaromyces funiculosus Penicillium funiculosum", "Thermoanaerobacter brockii", "Thermoanaerobacterium aotearoense", "Thermoanaerobacterium thermosaccharolyticum", "Thermotoga naphthophila", "Thermotoga petrophila"]
	return specie[s]


# Saving results ************************************************************************************************************************
w = open("result.txt",'w')
w.write("Mutation\tddGTS\tTemplate wild\tTemplate mutant\n")

num_mutations = 27
id_mutant = num_tolerants
id_wild = id_mutant + num_mutations

for i in range(num_mutations):

	mutation_name = translateMutation(i)
	template_wild_name = translateSpecie(nearest[id_wild])
	template_mutant_name = translateSpecie(nearest[id_mutant])

	w.write(str(mutation_name)+"\t"+str(ddGTS[i])+"\t"+str(template_wild_name)+"\t"+str(template_mutant_name)+"\n")

	id_mutant += 1
	id_wild += 1

w.close()

print "Successful | Results saved at result.txt"
